(function()
{
    /* hack to handle IE */
    if (window.addEventListener){
        window.addEventListener('load', onLoad, false); 
    } else if (window.attachEvent){
        window.attachEvent('onload', onLoad);
    }
    if (!window.XMLHttpRequest)
    {
        if (window.ActiveXObject)
        {
            window.XMLHttpRequest = function() { return new ActiveXObject("Microsoft.XMLHTTP") }
        }
    }
    
    function onLoad()
    {
        var _nonce          = document.getElementById('nonce');
        var _servicePath    = document.getElementById('servicePath');
        
        var _join           = document.getElementById('join');
        var _urlHang        = _servicePath.value +'/api/comm/1.0/hang';
        var _name           = document.getElementById('name');
        var _cliffId        = document.getElementById('cliffId');
        var _hangError      = document.getElementById('hangError');
        
        var _shout          = document.getElementById('shout');
        var _urlBroadcast   = _servicePath.value +'/api/comm/1.0/broadcast';        
        var _message        = document.getElementById('message');
        var _appName        = document.getElementById('appName');
        var _favicon        = document.getElementById('favicon').value;
        var _currentPath    = document.getElementById('currentPath');
        var _shoutError     = document.getElementById('shoutError');
        
        var _urlSoundSwitch = _servicePath.value +'/api/shoutbox/1.0/sound';
        var _joinSound      = document.getElementById('joinSound');
        var _soundFlag      = document.getElementById('soundFlag');
        
        /* hack to handle IE */
        if(_soundFlag)
        {
            if (_soundFlag.addEventListener){
                _soundFlag.addEventListener('click', toggleSound, false); 
            } else if (_soundFlag.attachEvent){
                _soundFlag.attachEvent('onclick', toggleSound);
            }
        }
        function toggleSound(e){
            switchTo = (_soundFlag.className == "unchecked")?"checked":"unchecked";
            var xhr = new window.XMLHttpRequest();
            xhr.open( 'GET', _urlSoundSwitch + "?" + "unite-sound=" + switchTo, true );
            xhr.onreadystatechange = function(){
                if( this.readyState!==4 )	return false;
                if( this.status==200 )
                {
                    _soundFlag.className = switchTo;
                    if(switchTo == "checked" && joinSound)
                    {
                        joinSound.innerHTML = '<iframe src="'+_servicePath.value+'/static/yusef_plugins_shoutbox/beep.wav"></frame>';
                    }
                }
            }
            xhr.send( );
            if (!e) var e = window.event;
            e.cancelBubble = true;
            if (e.stopPropagation) e.stopPropagation();
            return false;
        }
        
        if(parent && parent.location )
        {
            try {
                _currentPath.value  = parent.location;
                var links = parent.document.getElementsByTagName("link");
                for (var i=0, link; link=links[i]; i++) {
                    if (link.type.match(/image/gi) && link.rel=="shortcut icon") {
                        _favicon = link.href.replace(/admin./i, "");
                    }
                }
            }catch(e){
                //opera.postError("can't access parent");
            }
        }
        
        var _active         = false;
        if (window.addEventListener){
            _join.addEventListener('click', onJoin, false); 
            _shout.addEventListener('click', onBroadcast, false); 
        } else if (window.attachEvent){
            _join.attachEvent('onclick', onJoin);
            _shout.attachEvent('onclick', onBroadcast);
            hangForm.onsubmit = function(e)
            {
                onJoin(e);
                
            }
            shoutForm.onsubmit = function(e)
            {
                onBroadcast(e);
            }
        }
        function onJoin(e){
            if(!_active){
                new _getRequest( 
                    _urlHang, 
                    "unite-nonce=" + _nonce.value + 
                    "&unite-name=" + _name.value + 
                    "&unite-cliffId=" + _cliffId.value +
                    "&unite-newConnection=true",
                    _hangError,
                    true,
                    true
                );
                _active = true;
            }
            if (!e) var e = window.event;
            e.cancelBubble = true;
            if (e.stopPropagation) e.stopPropagation();
            e.preventDefault();
            return false;
        }
        
        function onBroadcast(e){
            new _postRequest( 
                _urlBroadcast, 
                "unite-nonce=" + _nonce.value + 
                "&unite-message=" + escape(_message.value) + 
                "&unite-appName=" + escape(_appName.value) + 
                "&unite-favicon=" + _favicon + 
                "&unite-currentPath=" + _currentPath.value + 
                "&unite-cliffId=" + _cliffId.value,
                _shoutError
            );
            if (!e) var e = window.event;
            e.cancelBubble = true;
            if (e.stopPropagation) e.stopPropagation();
            e.preventDefault();
            return false;
        }
        
        /**/
        var _hang           = document.getElementById('hang');
        var _shoutbox       = document.getElementById('shoutbox');
        function toggleShoutbox( join )
        {
            if( join )
            {
                _hang.style.display = "block";
                _shoutbox.style.display = "none";
            } else {
                _hang.style.display = "none";
                _shoutbox.style.display = "block";
            }
        }
        
        /**/
        var _messageList    = document.getElementById('messageList');
        function _addItems( rawMessages )
        {
            var messageList = rawMessages.split(/\r\n|\r|\n/);
            for(var i=0; i<messageList.length; i++)
            {
                _addItem( messageList[i] );
            }
            return 0;
        }
        function _addItem( message )
        {
            _messageList.innerHTML += message;
            _messageList.scrollTop = _messageList.scrollHeight;
            _message.focus();
            
        }
        
        /**/
        function _getRequest( _url, _vars, _getErrorElement, _reconnect, newConnection )
        {   
            function _readyState()
            {
                if(this.readyState==2)
                {
                    toggleShoutbox( false );
                }
                if( this.readyState!==4 )	return false;
                if( this.status==200 )
                {
                    var div = document.createElement("div");
                    div.innerHTML = this.responseText;
                    var xml = div;
                    if( xml )
                    {
                        var error = (xml.getElementsByTagName('error')[0]||{textContent:''}).textContent;
                    } else {
                        var nothing = "asda";
                    }
                    if(error){
                        toggleShoutbox( true );
                        _getErrorElement.textContent = error;
                    } else {
                        _addItem( this.responseText );
                        if(_soundFlag && this.responseText.indexOf('class="server"')>0 && _soundFlag.className=="checked" && !newConnection){
                            joinSound.innerHTML = '<iframe src="'+_servicePath.value+'/static/yusef_plugins_shoutbox/beep.wav"></frame>';
                        }
                        if(_reconnect)
                        {
                            _vars = _vars.replace(/&unite-newConnection=true/gi, "");
                            new _getRequest( _url, _vars, _getErrorElement, _reconnect );
                        }
                    }
                } else {
                    _getErrorElement.textContent += window.errors.CONNECTION_ERROR;
                }
                _active = false;
            }
            
            var xhr = new window.XMLHttpRequest();
            _vars = _vars||"";
            xhr.open( 'GET', _url + "?" + _vars, true );
            xhr.onreadystatechange = _readyState;
            xhr.send( );
        }
        
        function _postRequest( _url, _vars, _postErrorElement )
        { 
            function _readyState()
            {
                if( this.readyState!==4 )	return false;
                if( this.status==400) window.location.reload();
                if( this.status==200 )
                {
                    _message.value = "";
                    var div = document.createElement("div");
                    div.innerHTML = this.responseText;
                    var xml = div;
                    //var xml = this.responseXML;alert(this.responseText );
                    if( xml )
                    {
                        try{
                        var newToken = (xml.getElementsByTagName('token')||[{textContent:''}])[0].textContent;
                        _nonce.value = newToken;
                        
                        var success = (xml.getElementsByTagName('success')[0]||{textContent:''}).textContent;
                        var error = (xml.getElementsByTagName('error')[0]||{textContent:''}).textContent;
                        
                        if(success){
                            _postErrorElement.textContent = "";
                        } else {
                            _postErrorElement.textContent = error;
                        }
                        } catch(e){
                            window.location.reload();
                        }
                    } else {
                    }
                } else {
                    _postErrorElement.textContent = window.errors.CONNECTION_ERROR;
                }
            }
            var xhr = new window.XMLHttpRequest();
            _vars = _vars||"";
            xhr.open( 'POST', _url , true );
            xhr.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
            xhr.onreadystatechange = _readyState;
            xhr.send( _vars );
            return true;
        }
        
        /* dispatch a click event, to join */
        if(_name.value != "")
        {
            if (document.createEventObject){
                // dispatch for IE
                var evt = document.createEventObject();
                return _join.fireEvent('onclick',evt)
            }
            else{
                // dispatch for firefox + others
                var evt = document.createEvent("HTMLEvents");
                evt.initEvent("click", true, true ); // event type,bubbling,cancelable
                return !_join.dispatchEvent(evt);
            }
        }
    }
})();