Yusef.addPlugin
(
    'shoutbox',
    function shoutbox(){
        var that = this;
        this._cliff = Yusef.plugins.comm.createCliff("shoutbox");
        this.getData = function( connection )
        {
            data = {
                js : "static/yusef_plugins_shoutbox/shoutbox_main.js"
            }
            return data;
        }
        this.getDataFor = function( connection, cliffId )
        {
            var data = {
              name            : "shoutbox",
              servicePath     : opera.io.webserver.currentServicePath.slice(0, -1),
              isMaster        : connection.isOwner || connection.isLocal,
              currentPath     : unescape((connection.request.queryItems['unite-currentPath']||[connection.request.uri])[0]),
              public_html     : '/static/yusef_plugins_shoutbox/',
              favicon         : unescape((connection.request.queryItems['unite-favicon']||[""])[0]),
              js              : "shoutbox_client.js",
              css             : "shoutbox_style.css",
              applicationName : unescape((connection.request.queryItems['unite-appName']||[opera.io.webserver.currentServiceName])[0]),
              nonce           : connection.session.nonce,
              cliffId         : cliffId,
              username        : opera.io.webserver.userName,
              nickname        : (connection.isLocal)?decodeURI(opera.io.webserver.userName):"",
              soundFlag       : widget.preferenceForKey( 'shoutbox_soundFlag' )
            };
            if(that._cliff.userData[connection.session.id])
            {
                data.nickname = that._cliff.userData[connection.session.id].name;
            }
            return data;
        }
                
        this.initialize = function()
        {
            var path = 'mountpoint://application/libraries/yusef/plugins/shoutbox';
            var public_html = Yusef.mountpoints.application.resolve( path+'/public_html' );
            if( public_html.exists )
            {
                Yusef.shareStaticDirectory( public_html,'yusef_plugins_shoutbox/' );
            }
            if(!widget.preferenceForKey( 'shoutbox_soundFlag' ))
            {
                widget.setPreferenceForKey( "unchecked", 'shoutbox_soundFlag' );
            }
            this.addAPIRoute
            (
                '1.0',
                /sound/,
                function( connection, matches )
                {
                    if( connection.isOwner==false )
                    {
                        connection.response.setStatusCode("403", "Forbidden");
                        return '<error type="access">'+_('Something went wrong.')+'</error>';
                    }
                    var switchTo = (connection.request.queryItems['unite-sound']||[""])[0];
                    if(switchTo == "checked")
                    {
                        widget.setPreferenceForKey( "checked", 'shoutbox_soundFlag' );
                        return "<success>checked</success>"
                    } else if(switchTo == "unchecked") {
                        widget.setPreferenceForKey( "unchecked", 'shoutbox_soundFlag' );
                        return "<success>unchecked</success>"
                    }
                }
            );

            
            Yusef.addSectionListener( "shoutbox", function( connection ) {
                var data = that.getDataFor( connection, "shoutbox" );
                var template = new Markuper( "libraries/yusef/plugins/shoutbox/shoutbox.html", data);
                return template.parse().html()
            },
            //  This plugin allows embedding in iFrames
            {
                ui: true,
                disableSameOriginCheckForFrames: true
            });
            
            this._cliff.formatData = function( newData )
            {
                var data = "";
                for(var i=0; message=newData.messages[i]; i++)
                {
                    message.humanReadable = new Date(message.timestamp).humanReadable();
                    message.shortStamp = new Date(message.timestamp).toLocaleTimeString();
                }

                var template = new Markuper( "libraries/yusef/plugins/shoutbox/message.html", newData);
                template.parse( newData );
                return template.select("#message")[0].innerHTML;
            }
        }
        
    },
    "initialize"
);