(function homeService()
{
    var self = this;

    function init()
    {
        var locales = Yusef.mountpoints.application.resolve("locales");
        Yusef.shareStaticDirectory(locales, "locales/");
    }

    function getTabs(connection)
    {
        var tabs = [
            {"title": _("Applications"), "isRoot": true, "class": "active"},
            {"title": _("Activity Feed"), "section": "activities"}
        ];
        /*{title: "Account", hideFromVisitors: true}*/
        
        if( connection.isOwner )
        {
            //tabs.push({"title": _("Help"), "section": "help"});
        }
        
        return tabs;
    }
    
    /*
     *  Yusef.addSectionListener '_index'
     */
     Yusef.addSectionListener
     (
         '_index',
         (function(connection)
         {
            if( connection.request.uri==='/_root/favicon.ico' )
            {
                var file = Yusef.mountpoints.application.resolve( '/public_html/favicon.ico' );
                Yusef.serveFile( connection, file );
                return false;
            }
            
            var data = {};
            data.isOwner = connection.isOwner;
            data.apps = [];
            data.status = Yusef.plugins.profile.getData().status;
            data.hasStatus = Yusef.plugins.profile.getData().hasStatus;
            data.username = opera.io.webserver.userName;
            
            var apps = opera.io.webserver.services;
            for (var i = 0, app; app = apps[i]; i++)
            {
                data.apps.push({ name: app.name,
                                 id: escape(app.originURL) || "default",
                                 uri: app.servicePath });
            }
            
            data.hasApps = (data.apps.length>0)?true:false;
            
            var template = new Markuper("templates/index.html", data);

            return {
                 content: template.parse(data).select(),
                 styles: [ { href: "style.css" } ],
                 tabs: Yusef.plugins.ui.generateTabs(getTabs(connection), connection)
            };
        }).bind(this)
     );

     Yusef.addSectionListener
     (
         'account',
         (function(connection)
         {
             if (!connection.isOwner)
             {
                  Yusef.emitErrorPage( connection );
                  return;
             }

             var data = {};
             data.name = widget.preferenceForKey("yusef.plugins.profile.account.name");
             data.email = widget.preferenceForKey("yusef.plugins.profile.account.email");
             data.country = widget.preferenceForKey("yusef.plugins.profile.account.country");

             var template = new Markuper("templates/account.html", data);

             return {
                  content: template.parse(data).select(),
                  styles: [ { href: "style.css" } ],
                  tabs: Yusef.plugins.ui.generateTabs(getTabs(connection), connection)
             };
         }).bind(this),
         {"ui": true}
     );
     
     init();
})();
